"""
__main__.py
====================================
The core file of the nwtoolkit
"""

import argparse
import nwtoolkit.utilities.color
import nwtoolkit.utilities.config as config
import sys

def main():
    """
    Primary entrypoint for nwtoolkit
    """
    parser = argparse.ArgumentParser(description='NWToolkit')
    parser.add_argument('plugin', type=str, help='The plugin to run', choices=config.pluginList.keys(), nargs='?', default='nwshell')
    parser.add_argument('pluginArgs', nargs='?')
    args = parser.parse_args()

    __import__(config.pluginList[args.plugin])
    pluginPath = config.pluginList[args.plugin]
    exec(f'{pluginPath}.entry({sys.argv[1:]})')
