import cmd2
import platform
import sys
import nwtoolkit.utilities.color as color
import nwtoolkit.utilities.config as config
import nwtoolkit.__version__
import inspect

logo = color.red('''
    _   ___       __   ______            ____   _ __
   / | / / |     / /  /_  __/___  ____  / / /__(_) /_
  /  |/ /| | /| / /    / / / __ \/ __ \/ / //_/ / __/
 / /|  / | |/ |/ /    / / / /_/ / /_/ / / ,< / / /_
/_/ |_/  |__/|__/    /_/  \____/\____/_/_/|_/_/\__/
''')

info = color.green(f'''
OS Version: {platform.platform()}
Python Version: {" ".join(str(sys.version).splitlines())}
Toolkit Version: {nwtoolkit.__version__.version}
Number of Plugins Loaded: {len(config.pluginList)}
''')

intro = '''
Welcome to the NetWitness Global Services Toolkit. Type help or ? to list commands.'''

def load(path):
    __import__(path)
    exec(f'{path}.entry([])')

class ToolkitShell(cmd2.Cmd):
    def __init__(self):
        shortcuts = cmd2.DEFAULT_SHORTCUTS
        shortcuts.update({
            'exit': 'quit'
            })
        super().__init__(shortcuts=shortcuts)
        self.intro = logo + info + intro
        for plugin in config.pluginList:
            pluginPath = config.pluginList[plugin]
            setattr(self, f'do_{plugin}', lambda x, path=pluginPath: load(path))

    def do_nwshell(self, args):
        pass

def entry(args):
    app = ToolkitShell()
    app.cmdloop()