'''
Author: Spooner
Date: 3/15/20
Purpose: Version 1 of port probe. User input required
Features next version <2>: Verbosity, multithreading
**SUPPORTS 11.3 APPLIANCES** 
-->11.4 support coming version 1.1
'''

import json
import os
import sys
import subprocess
from itertools import chain
import nwtoolkit.utilities
import nwtoolkit.utilities.environment
from nwtoolkit.utilities.constants.ports import Components, Services
from nwtoolkit.utilities.connection import SSH_To_Head

dev = ''
appliance_ip = ''
source_ip = ''
e_services = []
serv_ports = []
serv_dict = {}
ION_cannon = False
ALL_dict = {}
head_mid = ''
#ae_services = []
#ae_serv_ports = []

def get_info():  # collects user input, will be deprectated version 2
    global dev
    global appliance_ip
    global source_ip
    global ION_cannon
    #print("\033[1;33;40m")
    print(nwtoolkit.utilities.color.blue('''
_____          _     _____ _               _    
| ___ \        | |   /  __ \ |             | |   
| |_/ /__  _ __| |_  | /  \/ |__   ___  ___| | __
|  __/ _ \| '__| __| | |   | '_ \ / _ \/ __| |/ /
| | | (_) | |  | |_  | \__/\ | | |  __/ (__|   < 
\_|  \___/|_|   \__|  \____/_| |_|\___|\___|_|\_\
                                                 
This program is able to test the connection between two specific appliances
(Ex. Decoder --> Cncentrator) or check ports on all aplliances.
Accepted service names *Type the name(s) exactly as shown below*:\n
************************************************************************* 
| Concentrator   | Network Decoder | Log Decoder | ESA                  |
| Archiver       | Broker          | Head Unit   | Endpoint Log Hybrid  |
| Relay Server   | Log Collector   | Log Hybrid  | Malware              |
| Network Hybrid | UEBA            | H&W Beta    | Log Retention Hybrid |
| ALL            |                 |             |                      |
*************************************************************************
'''))
    dev = input("Enter target appliance type: ")
    if dev != "ALL":
        appliance_ip = input("Enter target appliance IP: ")
        source_ip = input("Enter appliance source IP: ")
    elif dev == "ALL":
        ION_cannon = True

def get_all_hosts():  # creates dictionary of services & IPs to test all appliance ports
    global head_mid
    for host in nwtoolkit.utilities.environment.hosts:
        i_serv = (nwtoolkit.utilities.environment.hosts[host].services)
        i_ip = (nwtoolkit.utilities.environment.hosts[host].ipv4)
        #print("DEBUG ONLY - "+i_serv+" "+i_ip)
        if nwtoolkit.utilities.environment.hosts[host].services == "AdminServer":
            head_mid = nwtoolkit.utilities.environment.hosts[host].minionid
            #print(utilities.environment.hosts[host].minionid)
        ALL_dict[i_ip] = i_serv
    # print(ALL_dict.items())

def scan(ae_services,ae_serv_ports,name,key_ip): #used in scan_all() function to scan parsed appliances
    comp = Components
    serv = Services
    # print(Components)
    print("\033[1;33;40m\nTesting: "+name+" -- "+key_ip)
    c_json = json.dumps(comp)
    c_dict = json.loads(c_json)
    for a, b in c_dict.items():
        if a == name:
        # print(b.items())
            for k, v in b.items():
                for s in v:
                    ae_services.append(s)
                    #print(s)
    s_json = json.dumps(serv)
    s_dict = json.loads(s_json)
    #print(s_dict)
    for a, b in s_dict.items():
        for i in ae_services:
            if i == a:
                ae_serv_ports.append(b)
    #print(ae_serv_ports)
    flat_ports = list(chain.from_iterable(ae_serv_ports))
    #print(flat_ports)
    shell = SSH_To_Head()
    num=0
    for port in flat_ports:
        test_port = str(port)
        #print("salt '"+head_mid+"' "+"network.connect "+key+" "+test_port)
        p_cmd=("salt '"+head_mid+"' "+"network.connect "+key_ip+" "+test_port)
        stdin, stdout, stderr = shell.sendCommand(p_cmd)
        scan_output = stdout
        #print(scan_output)
        for line in scan_output:
            #useful_output = .join(line)
            if "Successfully" in line:
                num+=1
                #print("\033[1;32;40m")
                useful_output =''.join("\033[1;32;40mPort: "+test_port+" is reachable")
                print(useful_output)
            elif "Unable" in line:
                useful_output =''.join("\033[1;31;40mPort: "+test_port+" is not reachable")
                print(useful_output)
    if(num==len(flat_ports)):
            print("\n\u2705 All "+str(num)+" service ports on the target appliance are open")
    else:
            print("\033[1;31;40m\n\u274C Only "+str(num)+" out of "+str(len(flat_ports))+" ports are open. Check service and/or firewall")

def get_ports():  # parses constants file for service info, used in specific 1:1 connection test
    global serv_ports
    global e_services
    comp = Components
    serv = Services
    # print(Components)
    c_json = json.dumps(comp)
    c_dict = json.loads(c_json)
    for a, b in c_dict.items():
        if a == dev:
            # print(b.items())
            for key, value in b.items():
                # print(value)
                for s in value:
                    # print s
                    e_services.append(s)
    s_json = json.dumps(serv)
    s_dict = json.loads(s_json)
    serv_dict = s_dict
    for a, b in s_dict.items():
        #print(a)
        #print(b)
        for i in e_services:
            # print(i)
            if i == a:
                # print(i)
                # print(b)
                serv_ports.append(b)

def scan_all(): #called after get_all_hosts() function, runs conditions and loops through data gathered from get_all_hosts()
    #print(ALL_dict.items())
    translate = {
        "AdminServer": "Head Unit",
        "ESAPrimary": "ESA",
        "ESASecondary": "ESA",
        "LogHybrid": "Log Hybrid",
        "EndpointLogHybrid": "Endpoint Log Hybrid",
        "NetworkHybrid": "Network Hybrid",
        "LogCollector": "Log Collector",
        "EndpointRelayServer": "Relay Server",
        "LogDecoder": "Log Decoder",
        "Search": "HW Beta",
        "LogHybridRetention": "Log Hybrid Retention",
        "Decoder": "Network Decoder"
    }
    for key, value in ALL_dict.items():
        #print(key)
        scan(ae_services = [],ae_serv_ports = [],name = translate.get(value, value),key_ip=key)

def probe():  # the lines regarding salt ID are not used now, but will be required in version 2
    flat_ports = list(chain.from_iterable(serv_ports))
    shell = SSH_To_Head()
    total_p = len(serv_ports)
    print("\033[2;35;40m \nTotal number of "+dev+" ports: "+str(total_p))
    num = 0
    for host in nwtoolkit.utilities.environment.hosts:
        if(nwtoolkit.utilities.environment.hosts[host].ipv4 == source_ip):
            print("\033[2;35;40m \nProbing: "+dev+" at "+appliance_ip+" from "+source_ip+" using ID "+host)
            for port in flat_ports:
                test_port = str(port)
                p_cmd=("salt '"+host+"' "+"network.connect "+appliance_ip+" "+test_port)
                stdin, stdout, stderr = shell.sendCommand(p_cmd)
                scan_output = stdout
                #print(scan_output)
                for line in scan_output:
                    if "Successfully" in line:
                        useful_output =''.join("\033[1;32;40mPort: "+test_port+" is reachable")
                        print(useful_output)
                        num+=1
                        #post toolkit 1.0 release...better verbose on port scans
                        #for a, b in serv_dict.items():
                        #    if(str(port) in str(b)):
                        #        print("\033[1;34;40m \nService: SSH | Port: 22 | Status: \033[1;32;40mSUCCESS")
                        #elif(port == 15671):'''
                    elif "Unable" in line:
                        useful_output =''.join("\033[1;31;40mPort: "+test_port+" is not reachable")
                        print(useful_output)
    if(num==total_p):
        print("\n\u2705 All "+str(num)+" service ports on the target appliance are open")
    else:
        print("\033[1;31;40m\n\u274C Only "+str(num)+" out of "+total_p+" ports are open. Check service and/or firewall")

def entry(args): #main function
    get_info() # user input
    if ION_cannon ==False: # 1:1 scanning (Ex. Decoder --> Concentrator)
        get_ports()
        probe()
    else: # Scan all hosts. 
        get_all_hosts()
        scan_all()