import json

Components = {
    'Head Unit': {
        'services': ['nginx', 'rabbitmq-ui', 'rabbitmq-ampqs','ssh', 'dns','salt','rsa_update_repo','mongodb','content_server','admin_server','integration_server','source_server','license_server']
    },
    'ESA': {
        'services':['rabbitmq-ui','ssh','mongodb','context_hub','application_port_30','application_port_35','application_port_36','rabbitmq_amqps','http','https']
    },
    'Archiver': {
        'services':['rabbitmq-ui','https','ssh','archiver_application_port_50008','archiver_application_port_ssl','archiver_application_port_rest',
                    'appliance_port_ssl','appliance_port_rest','rabbitmq-amqps','workbench_514','workbench_6514','workbench_non-ssl','workbench_ssl','workbench_rest','workbench_udp']    
    },
    'Broker': {
        'services':['rabbitmq-ui','ssh','rsa_update_repo','broker_application_port_non-ssl','broker_application_port_ssl','broker_application_port_rest','appliance_port_ssl',
               'appliance_port_rest','rabbitmq-ampqs']
    },
    'Concentrator': {
        'services':['rabbitmq-ui','ssh','conc_application_ports_non-ssl','conc_application_port_ssl','conc_application_port_rest','malware_non-ssl','malware_ssl','appliance_port_ssl',
                    'appliance_port_rest','rabbitmq_amqps']
        },
    'Endpoint Log Hybrid': {
        'services':['nginx_tcp','nginx_udp','ui-web-7050','ui-web-7054','collector_app_port_non-ssl','collector_app_port_ssl','collector_app_port_rest','decoder_app_port_non-ssl'
                    'decoder_app_port_ssl','decoder_app_port_rest','rabbitmq-ui']
        },
    'Relay Server': {
        'services': ['forward_data','pull_data']
        },
    'Log Collector': {
        'services': ['rabbitmq-ui','ssh','syslog_tcp','snmp_udp','syslog_udp','netflow_2055_udp','netflow_4739_udp','netflow_6343_udp','netflow_9995_udp','ftp/s_21','ftp/s_64000',
         'ftp/s_64001','ftp/s_64002','ftp/s_64003','ftp/s_64004','ftp/s_64005','ftp/s_64006','ftp/s_64007','ftp/s_64008','ftp/s_64009','collector_app_port_non-ssl',
         'collector_app_port_ssl','collector_app_port_rest','appliance_port_ssl','appliance_port_rest','rabbitmq-amqps','virtual_collector_pull','collector_push']
        },
    'Log Decoder': {
        'services': ['rabbitmq-ui','ssh','syslog_tcp','snmp_udp','syslog_udp','netflow_2055_udp','netflow_4739_udp','netflow_6343_udp','netflow_9995_udp','ftp/s_21','ftp/s_64000',
         'ftp/s_64001','ftp/s_64002','ftp/s_64003','ftp/s_64004','ftp/s_64005','ftp/s_64006','ftp/s_64007','ftp/s_64008','ftp/s_64009','collector_app_port_non-ssl',
         'collector_app_port_ssl','collector_app_port_rest','decoder_app_port_non-ssl','decoder_app_port_ssl','decoder_app_port_rest','decoder_app_port_endpoint','appliance_port_ssl',
         'appliance_port_rest','rabbitmq-amqps','virtual_collector_pull','collector_push']
        },
    'Log Hybrid': {
        'services': ['rabbitmq-ui','ssh','syslog_tcp','snmp_udp','syslog_udp','netflow_2055_udp','netflow_4739_udp','netflow_6343_udp','netflow_9995_udp','ftp/s_21','ftp/s_64000',
         'ftp/s_64001','ftp/s_64002','ftp/s_64003','ftp/s_64004','ftp/s_64005','ftp/s_64006','ftp/s_64007','ftp/s_64008','ftp/s_64009','collector_app_port_non-ssl',
         'collector_app_port_ssl','collector_app_port_rest','decoder_app_port_non-ssl','decoder_app_port_ssl','decoder_app_port_rest','decoder_app_port_endpoint', 
         'conc_application_ports_non-ssl','conc_application_ports_ssl','conc_application_ports_rest','appliance_port_ssl','appliance_port_rest','rabbitmq-amqps']
        },
    'Malware': {
        'services': ['rabbitmq-ui','ssh','mal_app_ports','appliance_port_ssl','appliance_port_rest', 'rabbitmq-ampq','postgresql','broker_application_port_ssl','broker_application_port_rest']
        },
    'Network Decoder': {
        'services': ['rabbitmq-ui','ssh','net_decoder_app_ports_non-ssl','net_decoder_app_ports_ssl','net_decoder_app_ports_rest','appliance_port_ssl','appliance_port_rest','rabbitmq-ampq']
        },
    'Network Hybrid': {
        'services': ['rabbitmq-ui','ssh','net_decoder_app_ports_non-ssl','net_decoder_app_ports_ssl','net_decoder_app_ports_rest','appliance_port_ssl','appliance_port_rest','rabbitmq-ampq',
         'conc_application_ports_non-ssl','conc_application_port_ssl','conc_application_port_rest']
        },
    'UEBA': {
        'services': ['ssh','monitoring','rabbitmq-ampq','rabbitmq-ui']
        },
    'Analyst UI': {
        'services': ['ssh','rabbitmq-ampq']
        },
    'HW Beta': {
        'services': ['ssh','rabbitmq-ampq','kibana','elasticsearch','rabbitmq-ui','metrics-server','node-infra']
        },
    'Log Retention Hybrid': {
        'services': ['rabbitmq-ui','ssh','syslog_tcp','snmp_udp','syslog_udp','netflow_2055_udp','netflow_4739_udp','netflow_6343_udp','netflow_9995_udp','ftp/s_21','ftp/s_64000',
         'ftp/s_64001','ftp/s_64002','ftp/s_64003','ftp/s_64004','ftp/s_64005','ftp/s_64006','ftp/s_64007','ftp/s_64008','ftp/s_64009','collector_app_port_non-ssl',
         'collector_app_port_ssl','collector_app_port_rest','decoder_app_port_non-ssl','decoder_app_port_ssl','decoder_app_port_rest','decoder_app_port_endpoint', 
         'appliance_port_ssl','appliance_port_rest','rabbitmq-amqps']
        }

}

Services = {
    'nginx': [80],
    'dns': [53],
    'rabbitmq-ui': [15671],
    'rabbitmq-ampqs' : [5671],
    'rsa_update_repo': [443],
    'ssh':[22],
    'postgresql':[5432],
    'mongodb': [27017],
    'context_hub': [7005],
    'application_port_30': [50030],
    'application_port_35': [50035],
    'application_port_36': [50036],
    'live': [443],
    'http': [80],
    'https': [443],
    'salt': [4505,4506],
    'network_application_port_non-ssl': [56004],
    'network_application_port_ssl': [50004],
    'archiver_application_port_50008': [50008],
    'archiver_application_port_ssl': [56008],
    'archiver_application_port_rest': [50108],
    'appliance_port_ssl': [56006],
    'appliance_port_rest': [50106],
    'broker_application_port_non-ssl': [50003],
    'broker_application_port_ssl': [56003],
    'broker_application_port_rest': [50103],
    'conc_application_ports_non-ssl': [50005],
    'conc_application_port_ssl': [56005],
    'conc_application_port_rest': [50105],
    'malware_non-ssl': [50005],
    'malware_ssl': [56006],
    'nginx_tcp': [443],
    'nginx_udp': [444],
    'ui-web-7050': [7050],
    'ui-web-7054': [7054],
    'collector_app_port_non-ssl': [50001],
    'collector_app_port_ssl': [56001],
    'collector_app_port_rest': [50101],
    'decoder_app_port_non-ssl': [50002],
    'decoder_app_port_ssl': [56002],
    'decoder_app_port_rest': [50102],
    'forward_data': [443],
    'pull_data': [443],
    'net_decoder_app_ports_ssl': [56004],
    'net_decoder_app_ports_rest': [50104],
    'net_decoder_app_ports_non-ssl': [50004],
    'monitoring': [443],
    'kibana': [5601],
    'elasticsearch': [9200],
    'metrics-server': [7018],
    'node-infra': [7020],
    'content_server': [7006],
    'admin_server': [7009],
    'integration_server': [7012],
    'source_server': [7015],
    'license_server': [7016]
}

def do_constants():
        'Displays constant values.'
        print(json.dumps(Services, sort_keys=True, indent=4))
        print(json.dumps(Components, sort_keys=True, indent=4))
